<!DOCTYPE html>
<html lang="en">
  <head>
    <title>Bootstrap Example</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>Task 33.20</title>
  </head>

  <body onload="onPageLoading();">
    <div class="container">
      <div class="text-center my-4">
        <h2>Danh sách người dùng đăng ký</h2>
      </div>
      <div>
        <button class="btn btn-success" id="btn-add-user">Thêm user</button>
      </div>
      <table
        class="table table-bordered table-striped table-hover"
        id="table-users"
      >
        <thead>
          <tr>
            <th>Id</th>
            <th>Firstname</th>
            <th>Lastname</th>
            <th>Country</th>
            <th>Subject</th>
            <th>Customer Type</th>
            <th>Register Status</th>
            <th>Action</th>
          </tr>
        </thead>
        <tbody></tbody>
      </table>
    </div>
    ​
    <script>
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

      /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      function onPageLoading() {
        callAPIGetDataUser();
      }

      //hàm load user data dùng ajax
      function callAPIGetDataUser() {
        "use strict";
        $.ajax({
          url: "http://203.171.20.210:8080/devcamp-register-java-api/users/",
          type: "GET",
          dataType: "json",
          success: function (res) {
            console.log(res);
            loadDataToTable(res);
          },
          error: function (ajaxContext) {
            alert(ajaxContext.responseText);
          },
        });
      }

      //gán event handler cho nút sửa
      $("#table-users").on("click", ".btn-edit", onBtnEditClick);
      //gán event handler cho nút xóa
      $("#table-users").on("click", ".btn-delete", onBtnDeleteClick);
      //gán event handler cho button add user
      $("#btn-add-user").on("click", onBtnInsertClick);

      //hàm gọi khi bấm nút sửa
      function onBtnEditClick() {
        "use strict";
        console.log("Nút sửa được nhấn.");
        console.log("id: " + $(this).data("data-id"));
        const vDETAIL_FORM_URL = "updateUser.html";
        var vUrlToOpenPage =
          vDETAIL_FORM_URL + "?" + "id=" + $(this).data("data-id");
        window.location.href = vUrlToOpenPage;
      }

      //hàm gọi khi bấm nút xóa
      function onBtnDeleteClick() {
        "use strict";
        var vId = $(this).data("data-id");
        console.log("Nút xóa được nhấn.");
        if (confirm("Bạn có thực sự muốn xóa không!") == true) {
          console.log("bạn đã xác nhận OK!");
          console.log("id: " + vId);
          callAPIDeleteDataUser(vId);
        } else {
          console.log("bạn đã xác nhận Canceled!");
        }
      }

      //hàm gọi khi bấm nút sửa
      function onBtnInsertClick() {
        "use strict";
        console.log("Nút thêm user mới được nhấn.");
        window.location.href = "insertUser.html";
      }

      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      function callAPIDeleteDataUser(paramId) {
        "use strict";
        $.ajax({
          url: "http://203.171.20.210:8080/crud-api/users/" + paramId,
          type: "DELETE",
          dataType: "json",
          success: function (res) {
            console.log(res);
            alert("bạn đã xóa thành công.");
            window.location.href = "task 33.20.html";
          },
          error: function (ajaxContext) {
            alert(ajaxContext.responseText);
          },
        });
      }

      function loadDataToTable(paramUserData) {
        var vTableUser = $("#table-users");
        $("#table-users tbody").empty();
        for (var bI = 0; bI < paramUserData.length; bI++) {
          const element = paramUserData[bI];
          var vNewRow = $("<tr>")
            .appendTo(vTableUser)
            .append($("<td>", { html: element.id }));

          $("<td>", { html: element.firstname }).appendTo(vNewRow);
          $("<td>", { html: element.lastname }).appendTo(vNewRow);
          $("<td>", { html: element.country }).appendTo(vNewRow);
          $("<td>", { html: element.subject }).appendTo(vNewRow);
          $("<td>", { html: element.customerType }).appendTo(vNewRow);
          $("<td>", { html: element.registerStatus }).appendTo(vNewRow);
          var bActionCel = $("<td>").appendTo(vNewRow);

          //tạo nút sửa
          var bActionButton = $("<button>", { html: "Sửa" })
            .addClass("btn btn-primary btn-edit")
            .data("data-id", element.id)
            .data("data-firstname", element.firstname)
            .data("data-lastname", element.lastname)
            .data("data-country", element.country)
            .data("data-subject", element.subject)
            .data("data-customerType", element.customerType)
            .data("data-registerStatus", element.registerStatus)
            .appendTo(bActionCel);

          //tạo nút delete
          var bActionButton = $("<button>", { html: "xóa" })
            .addClass("btn btn-danger btn-delete")
            .data("data-id", element.id)
            .data("data-firstname", element.firstname)
            .data("data-lastname", element.lastname)
            .data("data-country", element.country)
            .data("data-subject", element.subject)
            .data("data-customerType", element.customerType)
            .data("data-registerStatus", element.registerStatus)
            .appendTo(bActionCel);
        }
      }
    </script>
  </body>
</html>
​
